/**
 */
package tools.descartes.prisma.agent.generic.genericagent.provider;


import java.util.Collection;
import java.util.List;

import org.eclipse.emf.cdo.edit.CDOItemProviderAdapter;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.common.util.ResourceLocator;

import org.eclipse.emf.ecore.EStructuralFeature;

import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;
import org.eclipse.emf.edit.provider.ItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ViewerNotification;

import tools.descartes.prisma.agent.generic.genericagent.GenericAgentConfiguration;
import tools.descartes.prisma.agent.generic.genericagent.GenericAgentFactory;
import tools.descartes.prisma.agent.generic.genericagent.GenericAgentPackage;

import tools.descartes.prisma.model.scope.ScopeFactory;

import tools.descartes.prisma.model.skeleton.SkeletonFactory;

/**
 * This is the item provider adapter for a {@link tools.descartes.prisma.agent.generic.genericagent.GenericAgentConfiguration} object.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class GenericAgentConfigurationItemProvider 
	extends CDOItemProviderAdapter
	implements
		IEditingDomainItemProvider,
		IStructuredItemContentProvider,
		ITreeItemContentProvider,
		IItemLabelProvider,
		IItemPropertySource {
	/**
	 * This constructs an instance from a factory and a notifier.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public GenericAgentConfigurationItemProvider(AdapterFactory adapterFactory) {
		super(adapterFactory);
	}

	/**
	 * This returns the property descriptors for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object) {
		if (itemPropertyDescriptors == null) {
			super.getPropertyDescriptors(object);

			addIdPropertyDescriptor(object);
		}
		return itemPropertyDescriptors;
	}

	/**
	 * This adds a property descriptor for the Id feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addIdPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_GenericAgentConfiguration_id_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_GenericAgentConfiguration_id_feature", "_UI_GenericAgentConfiguration_type"),
				 GenericAgentPackage.Literals.GENERIC_AGENT_CONFIGURATION__ID,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
				 null,
				 null));
	}

	/**
	 * This specifies how to implement {@link #getChildren} and is used to deduce an appropriate feature for an
	 * {@link org.eclipse.emf.edit.command.AddCommand}, {@link org.eclipse.emf.edit.command.RemoveCommand} or
	 * {@link org.eclipse.emf.edit.command.MoveCommand} in {@link #createCommand}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Collection<? extends EStructuralFeature> getChildrenFeatures(Object object) {
		if (childrenFeatures == null) {
			super.getChildrenFeatures(object);
			childrenFeatures.add(GenericAgentPackage.Literals.GENERIC_AGENT_CONFIGURATION__SCOPE);
			childrenFeatures.add(GenericAgentPackage.Literals.GENERIC_AGENT_CONFIGURATION__REQUIRED_OBJECTS);
			childrenFeatures.add(GenericAgentPackage.Literals.GENERIC_AGENT_CONFIGURATION__SKELETON);
			childrenFeatures.add(GenericAgentPackage.Literals.GENERIC_AGENT_CONFIGURATION__DELEGATIONS);
		}
		return childrenFeatures;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EStructuralFeature getChildFeature(Object object, Object child) {
		// Check the type of the specified child object and return the proper feature to use for
		// adding (see {@link AddCommand}) it as a child.

		return super.getChildFeature(object, child);
	}

	/**
	 * This returns GenericAgentConfiguration.gif.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object getImage(Object object) {
		return overlayImage(object, getResourceLocator().getImage("full/obj16/GenericAgentConfiguration"));
	}

	/**
	 * This returns the label text for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getText(Object object) {
		String label = ((GenericAgentConfiguration)object).getId();
		return label == null || label.length() == 0 ?
			getString("_UI_GenericAgentConfiguration_type") :
			getString("_UI_GenericAgentConfiguration_type") + " " + label;
	}
	

	/**
	 * This handles model notifications by calling {@link #updateChildren} to update any cached
	 * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void notifyChanged(Notification notification) {
		updateChildren(notification);

		switch (notification.getFeatureID(GenericAgentConfiguration.class)) {
			case GenericAgentPackage.GENERIC_AGENT_CONFIGURATION__ID:
				fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), false, true));
				return;
			case GenericAgentPackage.GENERIC_AGENT_CONFIGURATION__SCOPE:
			case GenericAgentPackage.GENERIC_AGENT_CONFIGURATION__REQUIRED_OBJECTS:
			case GenericAgentPackage.GENERIC_AGENT_CONFIGURATION__SKELETON:
			case GenericAgentPackage.GENERIC_AGENT_CONFIGURATION__DELEGATIONS:
				fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), true, false));
				return;
		}
		super.notifyChanged(notification);
	}

	/**
	 * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s describing the children
	 * that can be created under this object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected void collectNewChildDescriptors(Collection<Object> newChildDescriptors, Object object) {
		super.collectNewChildDescriptors(newChildDescriptors, object);

		newChildDescriptors.add
			(createChildParameter
				(GenericAgentPackage.Literals.GENERIC_AGENT_CONFIGURATION__SCOPE,
				 ScopeFactory.eINSTANCE.createScopeReference()));

		newChildDescriptors.add
			(createChildParameter
				(GenericAgentPackage.Literals.GENERIC_AGENT_CONFIGURATION__SKELETON,
				 SkeletonFactory.eINSTANCE.createModelSkeleton()));

		newChildDescriptors.add
			(createChildParameter
				(GenericAgentPackage.Literals.GENERIC_AGENT_CONFIGURATION__DELEGATIONS,
				 GenericAgentFactory.eINSTANCE.createDelegationDestination()));
	}

	/**
	 * Return the resource locator for this item provider's resources.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public ResourceLocator getResourceLocator() {
		return GenericagentEditPlugin.INSTANCE;
	}

}
