package tools.descartes.prisma.core;

import java.util.Map;

public interface MessageBus {

	public interface Listener {
		void newMessage(String exchange, String routingKey, Map<String, Object> headers, String message);
	}

	public enum ExchangeType {
		DIRECT, FANOUT, TOPIC, HEADERS
	}

	void connect();

	void disconnect();

	void createQueue(String queue);

	void removeQueue(String queue);

	void createExchange(String exchange, ExchangeType type);

	void removeExchange(String exchange);

	void bindQueue(String queue, String exchange, String routingKey);

	void addMessageListener(String queue, final Listener listener);

	void publishMessage(String exchange, String routingKey, String message, Map<String, Object> headers);

}
